<?php
/**
 * WARNING: Do not edit by hand, this file was generated by Crank:
 *
 * https://github.com/gocardless/crank
 */

namespace GoCardlessPro\Resources;

/**
 * A thin wrapper around a bank_authorisation, providing access to its
 * attributes
 *
 * @property-read $authorisation_type
 * @property-read $authorised_at
 * @property-read $created_at
 * @property-read $expires_at
 * @property-read $id
 * @property-read $last_visited_at
 * @property-read $links
 * @property-read $redirect_uri
 * @property-read $url
 */
class BankAuthorisation extends BaseResource
{
    protected $model_name = "BankAuthorisation";

    /**
     * Type of authorisation, can be either 'mandate' or 'payment'.
     */
    protected $authorisation_type;

    /**
     * Fixed [timestamp](#api-usage-time-zones--dates), recording when the user
     * has been authorised.
     */
    protected $authorised_at;

    /**
     * Timestamp when the flow was created
     */
    protected $created_at;

    /**
     * Timestamp when the url will expire. Each authorisation url currently
     * lasts for 15 minutes, but this can vary by bank.
     */
    protected $expires_at;

    /**
     * Unique identifier, beginning with "BAU".
     */
    protected $id;

    /**
     * Fixed [timestamp](#api-usage-time-zones--dates), recording when the
     * authorisation URL has been visited.
     */
    protected $last_visited_at;

    /**
     * 
     */
    protected $links;

    /**
     * URL that the payer can be redirected to after authorising the payment.
     * 
     * On completion of bank authorisation, the query parameter of either
     * `outcome=success` or `outcome=failure` will be
     * appended to the `redirect_uri` to indicate the result of the bank
     * authorisation. If the bank authorisation is
     * expired, the query parameter `outcome=timeout` will be appended to the
     * `redirect_uri`, in which case you should
     * prompt the user to try the bank authorisation step again.
     * 
     * The `redirect_uri` you provide should handle the `outcome` query
     * parameter for displaying the result of the
     * bank authorisation as outlined above.
     * 
     * The BillingRequestFlow ID will also be appended to the `redirect_uri` as
     * query parameter `id=BRF123`.
     * 
     * Defaults to `https://pay.gocardless.com/billing/static/thankyou`.
     */
    protected $redirect_uri;

    /**
     * URL for an oauth flow that will allow the user to authorise the payment
     */
    protected $url;

}
