<?php
/**
 * WARNING: Do not edit by hand, this file was generated by Crank:
 *
 * https://github.com/gocardless/crank
 */

namespace GoCardlessPro\Resources;

/**
 * A thin wrapper around a event, providing access to its
 * attributes
 *
 * @property-read $action
 * @property-read $created_at
 * @property-read $customer_notifications
 * @property-read $details
 * @property-read $id
 * @property-read $links
 * @property-read $metadata
 * @property-read $resource_type
 */
class Event extends BaseResource
{
    protected $model_name = "Event";

    /**
     * What has happened to the resource. See [Event Actions](#event-actions)
     * for the possible actions.
     */
    protected $action;

    /**
     * Fixed [timestamp](#api-usage-time-zones--dates), recording when this
     * resource was created.
     */
    protected $created_at;

    /**
     * Present only in webhooks when an integrator is authorised to send their
     * own
     * notifications. See
     * [here](/getting-started/api/handling-customer-notifications/)
     * for further information.
     */
    protected $customer_notifications;

    /**
     * 
     */
    protected $details;

    /**
     * Unique identifier, beginning with "EV".
     */
    protected $id;

    /**
     * 
     */
    protected $links;

    /**
     * If the `details[origin]` is `api`, this will contain any metadata you
     * specified when triggering this event. In other cases it will be an empty
     * object.
     */
    protected $metadata;

    /**
     * The resource type for this event. One of:
     * <ul>
     * <li>`billing_requests`</li>
     * <li>`creditors`</li>
     * <li>`instalment_schedules`</li>
     * <li>`mandates`</li>
     * <li>`payer_authorisations`</li>
     * <li>`payments`</li>
     * <li>`payouts`</li>
     * <li>`refunds`</li>
     * <li>`scheme_identifiers`</li>
     * <li>`subscriptions`</li>
     * </ul>
     */
    protected $resource_type;

}
