<?php
/**
 * WARNING: Do not edit by hand, this file was generated by Crank:
 *
 * https://github.com/gocardless/crank
 */

namespace GoCardlessPro\Services;

use \GoCardlessPro\Core\Paginator;
use \GoCardlessPro\Core\Util;
use \GoCardlessPro\Core\ListResponse;
use \GoCardlessPro\Resources\Institution;
use \GoCardlessPro\Core\Exception\InvalidStateException;


/**
 * Service that provides access to the Institution
 * endpoints of the API
 *
 * @method list()
 * @method listForBillingRequest()
 */
class InstitutionsService extends BaseService
{

    protected $envelope_key   = 'institutions';
    protected $resource_class = '\GoCardlessPro\Resources\Institution';


    /**
     * List Institutions
     *
     * Example URL: /institutions
     *
     * @param  string[mixed] $params An associative array for any params
     * @return ListResponse
     **/
    protected function _doList($params = array())
    {
        $path = "/institutions";
        if(isset($params['params'])) { $params['query'] = $params['params'];
            unset($params['params']);
        }

        
        $response = $this->api_client->get($path, $params);
        

        return $this->getResourceForResponse($response);
    }

    /**
     * List institutions for Billing Request
     *
     * Example URL: /billing_requests/:identity/institutions
     *
     * @param  string        $identity Unique identifier, beginning with "BRQ".
     * @param  string[mixed] $params   An associative array for any params
     * @return ListResponse
     **/
    public function listForBillingRequest($identity, $params = array())
    {
        $path = Util::subUrl(
            '/billing_requests/:identity/institutions',
            array(
                
                'identity' => $identity
            )
        );
        if(isset($params['params'])) { $params['query'] = $params['params'];
            unset($params['params']);
        }

        
        $response = $this->api_client->get($path, $params);
        

        return $this->getResourceForResponse($response);
    }

    /**
     * List Institutions
     *
     * Example URL: /institutions
     *
     * @param  string[mixed] $params
     * @return Paginator
     **/
    public function all($params = array())
    {
        return new Paginator($this, $params);
    }

}
