---
name: Bug Report
about: Create a report to help us improve
title: "[BUG]"
labels: bug
assignees: horstoeko

---

### Before Submitting an Issue

Thank you for contributing to our project! :tada: Before opening a new issue, please review our [Contributing Guidelines](https://github.com/horstoeko/zugferd/blob/master/CONTRIBUTING.md).

To help us assist you efficiently, we require confirmation of the following:
- [ ] I have read the [documentation](https://github.com/horstoeko/zugferd/wiki) and could not find a solution to my issue.
- [ ] I have searched open and closed [issues](https://github.com/horstoeko/zugferd/issues) to ensure my issue has not already been reported.

Issues that do not meet these requirements may be closed without further action. Thank you for your understanding and support! :pray:

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behavior:

**Expected behavior**
A clear and concise description of what you expected to happen.

**Screenshots**
If applicable, add screenshots to help explain your problem.

**Sample Code
If applicable, add (sample) code to help explain your problem.

**Additional information:**
 - OS: [e.g. Windows/Limux/etc.]
 - OS-Version [e.g. Windows10,Debian10,etc.]
 - PHP-Version [e.g. PHP7.x,PHP8.x,etc.]

**Additional context**
Add any other context about the problem here.
