<?php

namespace CleverIt\UBL\Invoice\Codes\V21;

class UnitCode
{
    public const UNIT = 'C62';
    public const PIECE = 'H87';

    public const SMALL_SPRAY  = '4';
    public const LIFT  = '5';
    public const HEAT_LOT  = '8';
    public const GROUP  = '10';
    public const OUTFIT  = '11';
    public const RATION  = '13';
    public const SHOT  = '14';
    public const STICK  = '15';
    public const HUNDRED_FIFTEEN_KG_DRUM  = '16';
    public const HUNDRED_LB_DRUM  = '17';
    public const FIFTYFIVE_GALLON_US_DRUM  = '18';
    public const TANK_TRUCK  = '19';
    public const TWENTY_FOOT_CONTAINER  = '20';
    public const FORTY_FOOT_CONTAINER  = '21';
    public const DECILITRE_PER_GRAM  = '22';
    public const GRAM_PER_CUBIC_CENTIMETRE  = '23';
    public const THEORETICAL_POUND  = '24';
    public const GRAM_PER_SQUARE_CENTIMETRE  = '25';
    public const ACTUAL_TON  = '26';
    public const THEORETICAL_TON  = '27';
    public const KILOGRAM_PER_SQUARE_METRE  = '28';
    public const POUND_PER_THOUSAND_SQUARE_FEET  = '29';
    public const HORSE_POWER_DAY_PER_AIR_DRY_METRIC_TON  = '30';
    public const CATCH_WEIGHT  = '31';
    public const KILOGRAM_PER_AIR_DRY_METRIC_TON  = '32';
    public const KILOPASCAL_SQUARE_METRES_PER_GRAM  = '33';
    public const KILOPASCALS_PER_MILLIMETRE  = '34';
    public const MILLILITRES_PER_SQUARE_CENTIMETRE_SECOND  = '35';
    public const CUBIC_FEET_PER_MINUTE_PER_SQUARE_FOOT  = '36';
    public const OUNCE_PER_SQUARE_FOOT  = '37';
    public const OUNCES_PER_SQUARE_FOOT_PER_001_INCH  = '38';
    public const MILLILITRE_PER_SECOND  = '40';
    public const MILLILITRE_PER_MINUTE  = '41';
    public const SUPER_BULK_BAG  = '43';
    public const FIVEHUNDRED_KG_BULK_BAG  = '44';
    public const THREEHUNDRED_KG_BULK_BAG  = '45';
    public const FIFTY_LB_BULK_BAG  = '46';
    public const FIFTY_LB_BAG  = '47';
    public const BULK_CAR_LOAD  = '48';
    public const THEORETICAL_KILOGRAMS  = '53';
    public const THEORETICAL_TONNE  = '54';
    public const SITAS  = '56';
    public const MESH  = '57';
    public const NET_KILOGRAM  = '58';
    public const PART_PER_MILLION  = '59';
    public const PERCENT_WEIGHT  = '60';
    public const PART_PER_BILLION_US  = '61';
    public const PERCENT_PER_1000_HOUR  = '62';
    public const FAILURE_RATE_IN_TIME  = '63';
    public const POUND_PER_SQUARE_INCH_GAUGE  = '64';
    public const OERSTED  = '66';
    public const TEST_SPECIFIC_SCALE  = '69';
    public const VOLT_AMPERE_PER_POUND  = '71';
    public const WATT_PER_POUND  = '72';
    public const AMPERE_TUM_PER_CENTIMETRE  = '73';
    public const MILLIPASCAL  = '74';
    public const GAUSS  = '76';
    public const MILLI_INCH  = '77';
    public const KILOGAUSS  = '78';
    public const POUNDS_PER_SQUARE_INCH_ABSOLUTE  = '80';
    public const HENRY  = '81';
    public const KILOPOUND_PER_SQUARE_INCH  = '84';
    public const FOOT_POUND_FORCE  = '85';
    public const POUND_PER_CUBIC_FOOT  = '87';
    public const POISE  = '89';
    public const SAYBOLD_UNIVERSAL_SECOND  = '90';
    public const STOKES  = '91';
    public const CALORIE_PER_CUBIC_CENTIMETRE  = '92';
    public const CALORIE_PER_GRAM  = '93';
    public const CURL_UNIT  = '94';
    public const TWENTY_THOUSAND_GALLON_US_TANKCAR  = '95';
    public const TEN_THOUSAND_GALLON_US_TANKCAR  = '96';
    public const TEN_KG_DRUM  = '97';
    public const FIFTEEN_KG_DRUM  = '98';
    public const CAR_MILE  = '1A';
    public const CAR_COUNT  = '1B';
    public const LOCOMOTIVE_COUNT  = '1C';
    public const CABOOSE_COUNT  = '1D';
    public const EMPTY_CAR  = '1E';
    public const TRAIN_MILE  = '1F';
    public const FUEL_USAGE_GALLON_US  = '1G';
    public const CABOOSE_MILE  = '1H';
    public const FIXED_RATE  = '1I';
    public const TON_MILE  = '1J';
    public const LOCOMOTIVE_MILE  = '1K';
    public const TOTAL_CAR_COUNT  = '1L';
    public const TOTAL_CAR_MILE  = '1M';
    public const QUARTER_MILE  = '1X';
    public const RADIAN_PER_SECOND  = '2A';
    public const RADIAN_PER_SECOND_SQUARED  = '2B';
    public const RÃ¶NTGEN  = '2C';
    public const BRITISH_THERMAL_UNIT_PER_HOUR  = '2I';
    public const CUBIC_CENTIMETRE_PER_SECOND  = '2J';
    public const CUBIC_FOOT_PER_HOUR  = '2K';
    public const CUBIC_FOOT_PER_MINUTE  = '2L';
    public const CENTIMETRE_PER_SECOND  = '2M';
    public const DECIBEL  = '2N';
    public const KILOBYTE  = '2P';
    public const KILOBECQUEREL  = '2Q';
    public const KILOCURIE  = '2R';
    public const MEGAGRAM  = '2U';
    public const MEGAGRAM_PER_HOUR  = '2V';
    public const BIN  = '2W';
    public const METRE_PER_MINUTE  = '2X';
    public const MILLIRÃ¶NTGEN  = '2Y';
    public const MILLIVOLT  = '2Z';
    public const MEGAJOULE  = '3B';
    public const MANMONTH  = '3C';
    public const POUND_PER_POUND_OF_PRODUCT  = '3E';
    public const POUND_PER_PIECE_OF_PRODUCT  = '3G';
    public const KILOGRAM_PER_KILOGRAM_OF_PRODUCT  = '3H';
    public const KILOGRAM_PER_PIECE_OF_PRODUCT  = '3I';
    public const BOBBIN  = '4A';
    public const CAP  = '4B';
    public const CENTISTOKES  = '4C';
    public const TWENTY_PACK  = '4E';
    public const MICROLITRE  = '4G';
    public const MICROMETRE_MICRON  = '4H';
    public const MILLIAMPERE  = '4K';
    public const MEGABYTE  = '4L';
    public const MILLIGRAM_PER_HOUR  = '4M';
    public const MEGABECQUEREL  = '4N';
    public const MICROFARAD  = '4O';
    public const NEWTON_PER_METRE  = '4P';
    public const OUNCE_INCH  = '4Q';
    public const OUNCE_FOOT  = '4R';
    public const PICOFARAD  = '4T';
    public const POUND_PER_HOUR  = '4U';
    public const TONUS_PER_HOUR  = '4W';
    public const KILOLITRE_PER_HOUR  = '4X';
    public const BARREL_PER_MINUTE  = '5A';
    public const BATCH  = '5B';
    public const GALLONUS_PER_THOUSAND  = '5C';
    public const MMSCF_DAY  = '5E';
    public const POUNDS_PER_THOUSAND  = '5F';
    public const PUMP  = '5G';
    public const STAGE  = '5H';
    public const STANDARD_CUBIC_FOOT  = '5I';
    public const HYDRAULIC_HORSE_POWER  = '5J';
    public const COUNT_PER_MINUTE  = '5K';
    public const SEISMIC_LEVEL  = '5P';
    public const SEISMIC_LINE  = '5Q';
    public const FIFTEEN_C_CALORIE  = 'A1';
    public const AMPERE_SQUARE_METRE_PER_JOULE_SECOND  = 'A10';
    public const Ã¥NGSTRÃ¶M  = 'A11';
    public const ASTRONOMICAL_UNIT  = 'A12';
    public const ATTOJOULE  = 'A13';
    public const BARN  = 'A14';
    public const BARN_PER_ELECTRON_VOLT  = 'A15';
    public const BARN_PER_STERADIAN_ELECTRON_VOLT  = 'A16';
    public const BARN_PER_STERDIAN  = 'A17';
    public const BECQUEREL_PER_KILOGRAM  = 'A18';
    public const BECQUEREL_PER_METRE_CUBED  = 'A19';
    public const AMPERE_PER_CENTIMETRE  = 'A2';
    public const BRITISH_THERMAL_UNIT_PER_SECOND_SQUARE_FOOT_DEGREE_RANKIN  = 'A20';
    public const BRITISH_THERMAL_UNIT_PER_POUND_DEGREE_RANKIN  = 'A21';
    public const BRITISH_THERMAL_UNIT_PER_SECOND_FOOT_DEGREE_RANKIN  = 'A22';
    public const BRITISH_THERMAL_UNIT_PER_HOUR_SQUARE_FOOT_DEGREE_RANKIN  = 'A23';
    public const CANDELA_PER_SQUARE_METRE  = 'A24';
    public const CHEVAL_VAPEUR  = 'A25';
    public const COULOMB_METRE  = 'A26';
    public const COULOMB_METRE_SQUARED_PER_VOLT  = 'A27';
    public const COULOMB_PER_CUBIC_CENTIMETRE  = 'A28';
    public const COULOMB_PER_CUBIC_METRE  = 'A29';
    public const AMPERE_PER_MILLIMETRE  = 'A3';
    public const COULOMB_PER_CUBIC_MILLIMETRE  = 'A30';
    public const COULOMB_PER_KILOGRAM_SECOND  = 'A31';
    public const COULOMB_PER_MOLE  = 'A32';
    public const COULOMB_PER_SQUARE_CENTIMETRE  = 'A33';
    public const COULOMB_PER_SQUARE_METRE  = 'A34';
    public const COULOMB_PER_SQUARE_MILLIMETRE  = 'A35';
    public const CUBIC_CENTIMETRE_PER_MOLE  = 'A36';
    public const CUBIC_DECIMETRE_PER_MOLE  = 'A37';
    public const CUBIC_METRE_PER_COULOMB  = 'A38';
    public const CUBIC_METRE_PER_KILOGRAM  = 'A39';
    public const AMPERE_PER_SQUARE_CENTIMETRE  = 'A4';
    public const CUBIC_METRE_PER_MOLE  = 'A40';
    public const AMPERE_PER_SQUARE_METRE  = 'A41';
    public const CURIE_PER_KILOGRAM  = 'A42';
    public const DEADWEIGHT_TONNAGE  = 'A43';
    public const DECALITRE  = 'A44';
    public const DECAMETRE  = 'A45';
    public const DECITEX  = 'A47';
    public const DEGREE_RANKIN  = 'A48';
    public const DENIER  = 'A49';
    public const AMPERE_SQUARE_METRE  = 'A5';
    public const DYN_SECOND_PER_CUBIC_CENTIMETRE  = 'A50';
    public const DYNE_SECOND_PER_CENTIMETRE  = 'A51';
    public const DYNE_SECOND_PER_CENTIMETRE_TO_THE_FIFTH  = 'A52';
    public const ELECTRONVOLT  = 'A53';
    public const ELECTRONVOLT__PER_METRE  = 'A54';
    public const ELECTRONVOLT_SQUARE_METRE  = 'A55';
    public const ELECTRONVOLT_SQUARE_METRE_PER_KILOGRAM  = 'A56';
    public const ERG  = 'A57';
    public const ERG_PER_CENTIMETRE  = 'A58';
    public const AMPERE_PER_SQUARE_METRE_KELVIN_SQUARED  = 'A6';
    public const ERG_PER_CUBIC_CENTIMETRE  = 'A60';
    public const ERG_PER_GRAM  = 'A61';
    public const ERG_PER_GRAM_SECOND  = 'A62';
    public const ERG_PER_SECOND  = 'A63';
    public const ERG_PER_SECOND_SQUARE_CENTIMETRE  = 'A64';
    public const ERG_PER_SQUARE_CENTIMETRE_SECOND  = 'A65';
    public const ERG_SQUARE_CENTIMETRE  = 'A66';
    public const ERG_SQUARE_CENTIMETRE_PER_GRAM  = 'A67';
    public const EXAJOULE  = 'A68';
    public const FARAD_PER_METRE  = 'A69';
    public const AMPERE_PER_SQUARE_MILLIMETRE  = 'A7';
    public const FEMTOJOULE  = 'A70';
    public const FEMTOMETRE  = 'A71';
    public const FOOT_PER_SECOND_SQUARED  = 'A73';
    public const FOOT_POUND_FORCE_PER_SECOND  = 'A74';
    public const FREIGHT_TON  = 'A75';
    public const GAL  = 'A76';
    public const GAUSSIAN_CGS_UNIT_OF_DISPLACEMENT  = 'A77';
    public const GAUSSIAN_CGS_UNIT_OF_ELECTIC_CURRENT  = 'A78';
    public const GAUSSIAN_CGS_UNIT_OF_ELECTRIC_CHARGE  = 'A79';
    public const AMPERE_SECOND  = 'A8';
    public const GAUSSIAN_CGS_UNIT_OF_ELECTRIC_FIELD_STRENGTH  = 'A80';
    public const GAUSSIAN_CGS_UNIT_OF_ELECTRIC_POLARIZATION  = 'A81';
    public const GAUSSIAN_CGS_UNIT_OF_ELECTRIC_POTENTIAL  = 'A82';
    public const GAUSSIAN_CGS_UNIT_OF_MAGNETIZATION  = 'A83';
    public const GIGACOULOMB_PER_CUBIC_METRE  = 'A84';
    public const GIGAELECTRONVOLT  = 'A85';
    public const GIGAHERTZ  = 'A86';
    public const GIGAOHM  = 'A87';
    public const GIGAOHM_METRE  = 'A88';
    public const GIGAPASCAL  = 'A89';
    public const RATE  = 'A9';
    public const GIGAWATT  = 'A90';
    public const GON  = 'A91';
    public const GRAM_PER_CUBIC_METRE  = 'A93';
    public const GRAM_PER_MOLE  = 'A94';
    public const GRAY  = 'A95';
    public const GRAY_PER_SECOND  = 'A96';
    public const HECTOPASCAL  = 'A97';
    public const HENRY_PER_METRE  = 'A98';
    public const BALL  = 'AA';
    public const BULK_PACK  = 'AB';
    public const ACRE  = 'ACR';
    public const BYTE  = 'AD';
    public const AMPERE_PER_METRE  = 'AE';
    public const ADDITIONAL_MINUTE  = 'AH';
    public const AVERAGE_MINUTE_PER_CALL  = 'AI';
    public const COP  = 'AJ';
    public const FATHOM  = 'AK';
    public const ACCESS_LINE  = 'AL';
    public const AMPOULE  = 'AM';
    public const AMPERE_HOUR  = 'AMH';
    public const AMPERE  = 'AMP';
    public const YEAR  = 'ANN';
    public const ALUMINIUM_POUND_ONLY  = 'AP';
    public const TROY_OUNCE_OR_APOTHECARIES_OUNCE  = 'APZ';
    public const ANTI_HEMOPHILIC_FACTOR_AHF_UNIT  = 'AQ';
    public const SUPPOSITORY  = 'AR';
    public const ARE  = 'ARE';
    public const ASSORTMENT  = 'AS';
    public const ALCOHOLIC_STRENGTH_BY_MASS  = 'ASM';
    public const ALCOHOLIC_STRENGTH_BY_VOLUME  = 'ASU';
    public const STANDARD_ATMOSPHERE  = 'ATM';
    public const TECHNICAL_ATMOSPHERE  = 'ATT';
    public const CAPSULE  = 'AV';
    public const POWDER_FILLED_VIAL  = 'AW';
    public const ASSEMBLY  = 'AY';
    public const BRITISH_THERMAL_UNIT_PER_POUND  = 'AZ';
    public const BTU_PER_CUBIC_FOOT  = 'B0';
    public const BARREL_US_PER_DAY  = 'B1';
    public const JOULE_PER_KILOGRAM_KELVIN  = 'B11';
    public const JOULE_PER_METRE  = 'B12';
    public const JOULE_PER_SQUARE_METRE  = 'B13';
    public const JOULE_PER_METRE_TO_THE_FOURTH_POWER  = 'B14';
    public const JOULE_PER_MOLE  = 'B15';
    public const JOULE_PER_MOLE_KELVIN  = 'B16';
    public const JOULE_SECOND  = 'B18';
    public const BUNK  = 'B2';
    public const JOULE_SQUARE_METRE_PER_KILOGRAM  = 'B20';
    public const KELVIN_PER_WATT  = 'B21';
    public const KILOAMPERE  = 'B22';
    public const KILOAMPERE_PER_SQUARE_METRE  = 'B23';
    public const KILOAMPERE_PER_METRE  = 'B24';
    public const KILOBECQUEREL_PER_KILOGRAM  = 'B25';
    public const KILOCOULOMB  = 'B26';
    public const KILOCOULOMB_PER_CUBIC_METRE  = 'B27';
    public const KILOCOULOMB_PER_SQUARE_METRE  = 'B28';
    public const KILOELECTRONVOLT  = 'B29';
    public const BATTING_POUND  = 'B3';
    public const KILOGRAM_METRE_PER_SECOND  = 'B31';
    public const KILOGRAM_METRE_SQUARED  = 'B32';
    public const KILOGRAM_METRE_SQUARED_PER_SECOND  = 'B33';
    public const KILOGRAM_PER_CUBIC_DECIMETRE  = 'B34';
    public const KILOGRAM_PER_LITRE  = 'B35';
    public const THERMOCHEMICAL_CALORIE_PER_GRAM  = 'B36';
    public const KILOGRAM_FORCE  = 'B37';
    public const KILOGRAM_FORCE_METRE  = 'B38';
    public const KILOGRAM_FORCE_METRE_PER_SECOND  = 'B39';
    public const BARREL_IMPERIAL  = 'B4';
    public const KILOGRAM_FORCE_PER_SQUARE_METRE  = 'B40';
    public const KILOJOULE_PER_KELVIN  = 'B41';
    public const KILOJOULE_PER_KILOGRAM  = 'B42';
    public const KILOJOULE_PER_KILOGRAM_KELVIN  = 'B43';
    public const KILOJOULE_PER_MOLE  = 'B44';
    public const KILOMOLE  = 'B45';
    public const KILOMOLE_PER_CUBIC_METRE  = 'B46';
    public const KILONEWTON  = 'B47';
    public const KILONEWTON_METRE  = 'B48';
    public const KILOOHM  = 'B49';
    public const BILLET  = 'B5';
    public const KILOOHM_METRE  = 'B50';
    public const KILOPOND  = 'B51';
    public const KILOSECOND  = 'B52';
    public const KILOSIEMENS  = 'B53';
    public const KILOSIEMENS_PER_METRE  = 'B54';
    public const KILOVOLT_PER_METRE  = 'B55';
    public const KILOWEBER_PER_METRE  = 'B56';
    public const LIGHT_YEAR  = 'B57';
    public const LITRE_PER_MOLE  = 'B58';
    public const LUMEN_HOUR  = 'B59';
    public const BUN  = 'B6';
    public const LUMEN_PER_SQUARE_METRE  = 'B60';
    public const LUMEN_PER_WATT  = 'B61';
    public const LUMEN_SECOND  = 'B62';
    public const LUX_HOUR  = 'B63';
    public const LUX_SECOND  = 'B64';
    public const MAXWELL  = 'B65';
    public const MEGAAMPERE_PER_SQUARE_METRE  = 'B66';
    public const MEGABECQUEREL_PER_KILOGRAM  = 'B67';
    public const MEGACOULOMB_PER_CUBIC_METRE  = 'B69';
    public const CYCLE  = 'B7';
    public const MEGACOULOMB_PER_SQUARE_METRE  = 'B70';
    public const MEGAELECTRONVOLT  = 'B71';
    public const MEGAGRAM_PER_CUBIC_METRE  = 'B72';
    public const MEGANEWTON  = 'B73';
    public const MEGANEWTON_METRE  = 'B74';
    public const MEGAOHM  = 'B75';
    public const MEGAOHM_METRE  = 'B76';
    public const MEGASIEMENS_PER_METRE  = 'B77';
    public const MEGAVOLT  = 'B78';
    public const MEGAVOLT_PER_METRE  = 'B79';
    public const JOULE_PER_CUBIC_METRE  = 'B8';
    public const RECIPROCAL_METRE_SQUARED_RECIPROCAL_SECOND  = 'B81';
    public const METRE_TO_THE_FOURTH_POWER  = 'B83';
    public const MICROAMPERE  = 'B84';
    public const MICROBAR  = 'B85';
    public const MICROCOULOMB  = 'B86';
    public const MICROCOULOMB_PER_CUBIC_METRE  = 'B87';
    public const MICROCOULOMB_PER_SQUARE_METRE  = 'B88';
    public const MICROFARAD_PER_METRE  = 'B89';
    public const BATT  = 'B9';
    public const MICROHENRY  = 'B90';
    public const MICROHENRY_PER_METRE  = 'B91';
    public const MICRONEWTON  = 'B92';
    public const MICRONEWTON_METRE  = 'B93';
    public const MICROOHM  = 'B94';
    public const MICROOHM_METRE  = 'B95';
    public const MICROPASCAL  = 'B96';
    public const MICRORADIAN  = 'B97';
    public const MICROSECOND  = 'B98';
    public const MICROSIEMENS  = 'B99';
    public const BAR  = 'BAR';
    public const BASE_BOX  = 'BB';
    public const BOARD  = 'BD';
    public const BUNDLE  = 'BE';
    public const BOARD_FOOT  = 'BFT';
    public const BAG  = 'BG';
    public const BRUSH  = 'BH';
    public const BRAKE_HORSE_POWER  = 'BHP';
    public const TRILLION_US  = 'BIL';
    public const BUCKET  = 'BJ';
    public const BASKET  = 'BK';
    public const BALE  = 'BL';
    public const DRY_BARREL_US  = 'BLD';
    public const BARREL_US_PETROLEUM_ETC  = 'BLL';
    public const BOTTLE  = 'BO';
    public const HUNDRED_BOARD_FEET  = 'BP';
    public const BECQUEREL  = 'BQL';
    public const LOWERCASE_BAR  = 'BR';
    public const BOLT  = 'BT';
    public const BRITISH_THERMAL_UNIT  = 'BTU';
    public const BUSHEL__US  = 'BUA';
    public const BUSHEL_UK  = 'BUI';
    public const BASE_WEIGHT  = 'BW';
    public const BOX  = 'BX';
    public const MILLION_BTUS  = 'BZ';
    public const CALL  = 'C0';
    public const COMPOSITE_PRODUCT_POUND_TOTAL_WEIGHT  = 'C1';
    public const MILLIFARAD  = 'C10';
    public const MILLIGAL  = 'C11';
    public const MILLIGRAM_PER_METRE  = 'C12';
    public const MILLIGRAY  = 'C13';
    public const MILLIHENRY  = 'C14';
    public const MILLIJOULE  = 'C15';
    public const MILLIMETRE_PER_SECOND  = 'C16';
    public const MILLIMETRE_SQUARED_PER_SECOND  = 'C17';
    public const MILLIMOLE  = 'C18';
    public const MOLE_PER_KILOGRAM  = 'C19';
    public const CARSET  = 'C2';
    public const MILLINEWTON  = 'C20';
    public const MILLINEWTON_PER_METRE  = 'C22';
    public const MILLIOHM_METRE  = 'C23';
    public const MILLIPASCAL_SECOND  = 'C24';
    public const MILLIRADIAN  = 'C25';
    public const MILLISECOND  = 'C26';
    public const MILLISIEMENS  = 'C27';
    public const MILLISIEVERT  = 'C28';
    public const MILLITESLA  = 'C29';
    public const MICROVOLT_PER_METRE  = 'C3';
    public const MILLIVOLT_PER_METRE  = 'C30';
    public const MILLIWATT  = 'C31';
    public const MILLIWATT_PER_SQUARE_METRE  = 'C32';
    public const MILLIWEBER  = 'C33';
    public const MOLE  = 'C34';
    public const MOLE_PER_CUBIC_DECIMETRE  = 'C35';
    public const MOLE_PER_CUBIC_METRE  = 'C36';
    public const MOLE_PER_LITRE  = 'C38';
    public const NANOAMPERE  = 'C39';
    public const CARLOAD  = 'C4';
    public const NANOCOULOMB  = 'C40';
    public const NANOFARAD  = 'C41';
    public const NANOFARAD_PER_METRE  = 'C42';
    public const NANOHENRY  = 'C43';
    public const NANOHENRY_PER_METRE  = 'C44';
    public const NANOMETRE  = 'C45';
    public const NANOOHM_METRE  = 'C46';
    public const NANOSECOND  = 'C47';
    public const NANOTESLA  = 'C48';
    public const NANOWATT  = 'C49';
    public const COST  = 'C5';
    public const NEPER  = 'C50';
    public const NEPER_PER_SECOND  = 'C51';
    public const PICOMETRE  = 'C52';
    public const NEWTON_METRE_SECOND  = 'C53';
    public const NEWTON_METRE_SQUARED__KILOGRAM_SQUARED  = 'C54';
    public const NEWTON_PER_SQUARE_METRE  = 'C55';
    public const NEWTON_PER_SQUARE_MILLIMETRE  = 'C56';
    public const NEWTON_SECOND  = 'C57';
    public const NEWTON_SECOND_PER_METRE  = 'C58';
    public const OCTAVE  = 'C59';
    public const CELL  = 'C6';
    public const OHM_CENTIMETRE  = 'C60';
    public const OHM_METRE  = 'C61';
    public const PARSEC  = 'C63';
    public const PASCAL_PER_KELVIN  = 'C64';
    public const PASCAL_SECOND  = 'C65';
    public const PASCAL_SECOND_PER_CUBIC_METRE  = 'C66';
    public const PASCAL_SECOND_PER_METRE  = 'C67';
    public const PETAJOULE  = 'C68';
    public const PHON  = 'C69';
    public const CENTIPOISE  = 'C7';
    public const PICOAMPERE  = 'C70';
    public const PICOCOULOMB  = 'C71';
    public const PICOFARAD_PER_METRE  = 'C72';
    public const PICOHENRY  = 'C73';
    public const PICOWATT  = 'C75';
    public const PICOWATT_PER_SQUARE_METRE  = 'C76';
    public const POUND_GAGE  = 'C77';
    public const POUND_FORCE  = 'C78';
    public const MILLICOULOMB_PER_KILOGRAM  = 'C8';
    public const RAD  = 'C80';
    public const RADIAN  = 'C81';
    public const RADIAN_METER_SQUARED_PER_MOLE  = 'C82';
    public const RADIAN_METRE_SQUARED_PER_KILOGRAM  = 'C83';
    public const RADIAN_PER_METRE  = 'C84';
    public const RECIPROCAL_ANGSTROM  = 'C85';
    public const RECIPROCAL_CUBIC_METRE  = 'C86';
    public const RECIPROCAL_CUBIC_METRE_PER_SECOND  = 'C87';
    public const RECIPROCAL_ELECTRON_VOLT_PER_CUBIC_METRE  = 'C88';
    public const RECIPROCAL_HENRY  = 'C89';
    public const COIL_GROUP  = 'C9';
    public const RECIPROCAL_JOULE_PER_CUBIC_METRE  = 'C90';
    public const RECIPROCAL_KELVIN_OR_KELVIN_TO_THE_POWER_MINUS_ONE  = 'C91';
    public const RECIPROCAL_METRE  = 'C92';
    public const RECIPROCAL_SQUARE_METRE  = 'C93';
    public const RECIPROCAL_MINUTE  = 'C94';
    public const RECIPROCAL_MOLE  = 'C95';
    public const RECIPROCAL_PASCAL_OR_PASCAL_TO_THE_POWER_MINUS_ONE  = 'C96';
    public const RECIPROCAL_SECOND  = 'C97';
    public const RECIPROCAL_SECOND_PER_CUBIC_METRE  = 'C98';
    public const RECIPROCAL_SECOND_PER_METRE_SQUARED  = 'C99';
    public const CAN  = 'CA';
    public const CARRYING_CAPACITY_IN_METRIC_TON  = 'CCT';
    public const CANDELA  = 'CDL';
    public const DEGREE_CELSIUS  = 'CEL';
    public const HUNDRED  = 'CEN';
    public const CARD  = 'CG';
    public const CENTIGRAM  = 'CGM';
    public const CONTAINER  = 'CH';
    public const CONE  = 'CJ';
    public const CONNECTOR  = 'CK';
    public const COULOMB_PER_KILOGRAM  = 'CKG';
    public const COIL  = 'CL';
    public const HUNDRED_LEAVE  = 'CLF';
    public const CENTILITRE  = 'CLT';
    public const SQUARE_CENTIMETRE  = 'CMK';
    public const CUBIC_CENTIMETRE  = 'CMQ';
    public const CENTIMETRE  = 'CMT';
    public const HUNDRED_PACK  = 'CNP';
    public const CENTAL_UK  = 'CNT';
    public const CARBOY  = 'CO';
    public const COULOMB  = 'COU';
    public const CARTRIDGE  = 'CQ';
    public const CRATE  = 'CR';
    public const CASE  = 'CS';
    public const CARTON  = 'CT';
    public const METRIC_CARAT  = 'CTM';
    public const CUP  = 'CU';
    public const CURIE  = 'CUR';
    public const COVER  = 'CV';
    public const HUNDRED_POUNDS_CWT_HUNDRED_WEIGHT_US  = 'CWA';
    public const HUNDRED_WEIGHT_UK  = 'CWI';
    public const CYLINDER  = 'CY';
    public const COMBO  = 'CZ';
    public const RECIPROCAL_SECOND_PER_STERADIAN  = 'D1';
    public const SIEMENS_PER_METRE  = 'D10';
    public const SIEMENS_SQUARE_METRE_PER_MOLE  = 'D12';
    public const SIEVERT  = 'D13';
    public const THOUSAND_LINEAR_YARD  = 'D14';
    public const SONE  = 'D15';
    public const SQUARE_CENTIMETRE_PER_ERG  = 'D16';
    public const SQUARE_CENTIMETRE_PER_STERADIAN_ERG  = 'D17';
    public const METRE_KELVIN  = 'D18';
    public const SQUARE_METRE_KELVIN_PER_WATT  = 'D19';
    public const RECIPROCAL_SECOND_PER_STERADIAN_METRE_SQUARED  = 'D2';
    public const SQUARE_METRE_PER_JOULE  = 'D20';
    public const SQUARE_METRE_PER_KILOGRAM  = 'D21';
    public const SQUARE_METRE_PER_MOLE  = 'D22';
    public const PEN_GRAM_PROTEIN  = 'D23';
    public const SQUARE_METRE_PER_STERADIAN  = 'D24';
    public const SQUARE_METRE_PER_STERADIAN_JOULE  = 'D25';
    public const SQUARE_METRE_PER_VOLT_SECOND  = 'D26';
    public const STERADIAN  = 'D27';
    public const SYPHON  = 'D28';
    public const TERAHERTZ  = 'D29';
    public const TERAJOULE  = 'D30';
    public const TERAWATT  = 'D31';
    public const TERAWATT_HOUR  = 'D32';
    public const TESLA  = 'D33';
    public const TEX  = 'D34';
    public const THERMOCHEMICAL_CALORIE  = 'D35';
    public const THERMOCHEMICAL_CALORIE_PER_GRAM_KELVIN  = 'D37';
    public const THERMOCHEMICAL_CALORIE_PER_SECOND_CENTIMETRE_KELVIN  = 'D38';
    public const THERMOCHEMICAL_CALORIE_PER_SECOND_SQUARE_CENTIMETRE_KELVIN  = 'D39';
    public const THOUSAND_LITRE  = 'D40';
    public const TONNE_PER_CUBIC_METRE  = 'D41';
    public const TROPICAL_YEAR  = 'D42';
    public const UNIFIED_ATOMIC_MASS_UNIT  = 'D43';
    public const VAR  = 'D44';
    public const VOLT__SQUARED_PER_KELVIN_SQUARED  = 'D45';
    public const VOLT___AMPERE  = 'D46';
    public const VOLT_PER_CENTIMETRE  = 'D47';
    public const VOLT_PER_KELVIN  = 'D48';
    public const MILLIVOLT_PER_KELVIN  = 'D49';
    public const KILOGRAM_PER_SQUARE_CENTIMETER  = 'D5';
    public const VOLT_PER_METRE  = 'D50';
    public const VOLT_PER_MILLIMETRE  = 'D51';
    public const WATT_PER_KELVIN  = 'D52';
    public const WATT_PER_METRE_KELVIN  = 'D53';
    public const WATT_PER_SQUARE_METRE  = 'D54';
    public const WATT_PER_SQUARE_METRE_KELVIN  = 'D55';
    public const WATT_PER_SQUARE_METRE_KELVIN_TO_THE_FOURTH_POWER  = 'D56';
    public const WATT_PER_STERADIAN  = 'D57';
    public const WATT_PER_STERADIAN_SQUARE_METRE  = 'D58';
    public const WEBER_PER_METRE  = 'D59';
    public const RÃ¶NTGEN_PER_SECOND  = 'D6';
    public const WEBER_PER_MILLIMETRE  = 'D60';
    public const MINUTE  = 'D61';
    public const SECOND_D62  = 'D62';
    public const BOOK  = 'D63';
    public const BLOCK  = 'D64';
    public const ROUND  = 'D65';
    public const CASSETTE  = 'D66';
    public const DOLLAR_PER_HOUR  = 'D67';
    public const INCH_TO_THE_FOURTH_POWER  = 'D69';
    public const SANDWICH  = 'D7';
    public const INTERNATIONAL_TABLE_IT_CALORIE  = 'D70';
    public const INTERNATIONAL_TABLE_IT_CALORIE_PER_SECOND_CENTIMETRE_KELVIN  = 'D71';
    public const INTERNATIONAL_TABLE_IT_CALORIE_PER_SECOND_SQUARE_CENTIMETRE_KELVIN  = 'D72';
    public const JOULE_SQUARE_METRE  = 'D73';
    public const KILOGRAM_PER_MOLE  = 'D74';
    public const INTERNATIONAL_TABLE_IT_CALORIE_PER_GRAM  = 'D75';
    public const INTERNATIONAL_TABLE_IT_CALORIE_PER_GRAM_KELVIN  = 'D76';
    public const MEGACOULOMB  = 'D77';
    public const BEAM  = 'D79';
    public const DRAIZE_SCORE  = 'D8';
    public const MICROWATT  = 'D80';
    public const MICROTESLA  = 'D81';
    public const MICROVOLT  = 'D82';
    public const MILLINEWTON_METRE  = 'D83';
    public const MICROWATT_PER_SQUARE_METRE  = 'D85';
    public const MILLICOULOMB  = 'D86';
    public const MILLIMOLE_PER_KILOGRAM  = 'D87';
    public const MILLICOULOMB_PER_CUBIC_METRE  = 'D88';
    public const MILLICOULOMB_PER_SQUARE_METRE  = 'D89';
    public const DYNE_PER_SQUARE_CENTIMETER  = 'D9';
    public const CUBIC_METRE_NET  = 'D90';
    public const REM  = 'D91';
    public const BAND  = 'D92';
    public const SECOND_PER_CUBIC_METRE  = 'D93';
    public const SECOND_PER_RADIAN_CUBIC_METRE  = 'D94';
    public const JOULE_PER_GRAM  = 'D95';
    public const POUND_GROSS  = 'D96';
    public const PALLET_UNIT_LOAD  = 'D97';
    public const MASS_POUND  = 'D98';
    public const SLEEVE  = 'D99';
    public const DECARE  = 'DAA';
    public const TEN_DAY  = 'DAD';
    public const DAY  = 'DAY';
    public const DRY_POUND  = 'DB';
    public const DISK_DISC  = 'DC';
    public const DEGREE  = 'DD';
    public const DEAL  = 'DE';
    public const DECADE  = 'DEC';
    public const DECIGRAM  = 'DG';
    public const DISPENSER  = 'DI';
    public const DECAGRAM  = 'DJ';
    public const DECILITRE  = 'DLT';
    public const SQUARE_DECIMETRE  = 'DMK';
    public const CUBIC_DECIMETRE  = 'DMQ';
    public const DECIMETRE  = 'DMT';
    public const DECINEWTON_METRE  = 'DN';
    public const DOZEN_PIECE  = 'DPC';
    public const DOZEN_PAIR  = 'DPR';
    public const DISPLACEMENT_TONNAGE  = 'DPT';
    public const DATA_RECORD  = 'DQ';
    public const DRUM  = 'DR';
    public const DRAM_US  = 'DRA';
    public const DRAM_UK  = 'DRI';
    public const DOZEN_ROLL  = 'DRL';
    public const DRACHM_UK  = 'DRM';
    public const DISPLAY  = 'DS';
    public const DRY_TON  = 'DT';
    public const DECITONNE  = 'DTN';
    public const DYNE  = 'DU';
    public const PENNYWEIGHT  = 'DWT';
    public const DYNE_PER_CENTIMETRE  = 'DX';
    public const DIRECTORY_BOOK  = 'DY';
    public const DOZEN  = 'DZN';
    public const DOZEN_PACK  = 'DZP';
    public const BELT  = 'E2';
    public const TRAILER  = 'E3';
    public const GROSS_KILOGRAM  = 'E4';
    public const METRIC_LONG_TON  = 'E5';
    public const EACH  = 'EA';
    public const ELECTRONIC_MAIL_BOX  = 'EB';
    public const EACH_PER_MONTH  = 'EC';
    public const ELEVEN_PACK  = 'EP';
    public const EQUIVALENT_GALLON  = 'EQ';
    public const ENVELOPE  = 'EV';
    public const THOUSAND_CUBIC_FEET_PER_DAY  = 'F1';
    public const FIBRE_PER_CUBIC_CENTIMETRE_OF_AIR  = 'F9';
    public const DEGREE_FAHRENHEIT  = 'FAH';
    public const FARAD  = 'FAR';
    public const FIELD  = 'FB';
    public const THOUSAND_CUBIC_FEET  = 'FC';
    public const MILLION_PARTICLE_PER_CUBIC_FOOT  = 'FD';
    public const TRACK_FOOT  = 'FE';
    public const HUNDRED_CUBIC_METRE  = 'FF';
    public const TRANSDERMAL_PATCH  = 'FG';
    public const MICROMOLE  = 'FH';
    public const FLAKE_TON  = 'FL';
    public const MILLION_CUBIC_FEET  = 'FM';
    public const FOOT  = 'FOT';
    public const POUND_PER_SQUARE_FOOT  = 'FP';
    public const FOOT_PER_MINUTE  = 'FR';
    public const FOOT_PER_SECOND  = 'FS';
    public const SQUARE_FOOT  = 'FTK';
    public const CUBIC_FOOT  = 'FTQ';
    public const US_GALLON_PER_MINUTE  = 'G2';
    public const IMPERIAL_GALLON_PER_MINUTE  = 'G3';
    public const MICROFICHE_SHEET  = 'G7';
    public const GALLON_US_PER_DAY  = 'GB';
    public const GIGABECQUEREL  = 'GBQ';
    public const GRAM_PER_100_GRAM  = 'GC';
    public const GROSS_BARREL  = 'GD';
    public const POUND_PER_GALLON_US  = 'GE';
    public const GRAM_PER_METRE_GRAM_PER_100_CENTIMETRES  = 'GF';
    public const GRAM_OF_FISSILE_ISOTOPE  = 'GFI';
    public const GREAT_GROSS  = 'GGR';
    public const HALF_GALLON_US  = 'GH';
    public const GILL_US  = 'GIA';
    public const GILL_UK  = 'GII';
    public const GRAM_PER_MILLILITRE  = 'GJ';
    public const GRAM_PER_KILOGRAM  = 'GK';
    public const GRAM_PER_LITRE  = 'GL';
    public const DRY_GALLON_US  = 'GLD';
    public const GALLON_UK  = 'GLI';
    public const GALLON_US  = 'GLL';
    public const GRAM_PER_SQUARE_METRE  = 'GM';
    public const GROSS_GALLON  = 'GN';
    public const MILLIGRAMS_PER_SQUARE_METRE  = 'GO';
    public const MILLIGRAM_PER_CUBIC_METRE  = 'GP';
    public const MICROGRAM_PER_CUBIC_METER  = 'GQ';
    public const GRAM  = 'GRM';
    public const GRAIN  = 'GRN';
    public const GROSS  = 'GRO';
    public const GROSS_REGISTER_TON  = 'GRT';
    public const GROSS_TON  = 'GT';
    public const GIGAJOULE  = 'GV';
    public const GALLON_PER_THOUSAND_CUBIC_FEET  = 'GW';
    public const GIGAWATT_HOUR  = 'GWH';
    public const GROSS_YARD  = 'GY';
    public const GAGE_SYSTEM  = 'GZ';
    public const HALF_PAGE___ELECTRONIC  = 'H1';
    public const HALF_LITRE  = 'H2';
    public const HANK  = 'HA';
    public const HECTARE  = 'HAR';
    public const HECTOBAR  = 'HBA';
    public const HUNDRED_BOXE  = 'HBX';
    public const HUNDRED_COUNT  = 'HC';
    public const HALF_DOZEN  = 'HD';
    public const HUNDREDTH_OF_A_CARAT  = 'HE';
    public const HUNDRED_FEET  = 'HF';
    public const HECTOGRAM  = 'HGM';
    public const HUNDRED_CUBIC_FEET  = 'HH';
    public const HUNDRED_SHEET  = 'HI';
    public const HUNDRED_INTERNATIONAL_UNIT  = 'HIU';
    public const METRIC_HORSE_POWER  = 'HJ';
    public const HUNDRED_KILOGRAM  = 'HK';
    public const HUNDRED_FEET_LINEAR  = 'HL';
    public const HECTOLITRE  = 'HLT';
    public const MILE_PER_HOUR  = 'HM';
    public const MILLION_CUBIC_METRE  = 'HMQ';
    public const HECTOMETRE  = 'HMT';
    public const CONVENTIONAL_MILLIMETRE_OF_MERCURY  = 'HN';
    public const HUNDRED_TROY_OUNCE  = 'HO';
    public const CONVENTIONAL_MILLIMETRE_OF_WATER  = 'HP';
    public const HECTOLITRE_OF_PURE_ALCOHOL  = 'HPA';
    public const HUNDRED_SQUARE_FEET  = 'HS';
    public const HALF_HOUR  = 'HT';
    public const HERTZ  = 'HTZ';
    public const HOUR  = 'HUR';
    public const HUNDRED_YARD  = 'HY';
    public const INCH_POUND_POUND_INCH  = 'IA';
    public const COUNT_PER_INCH  = 'IC';
    public const PERSON  = 'IE';
    public const INCHES_OF_WATER  = 'IF';
    public const COLUMN_INCH  = 'II';
    public const INCH_PER_MINUTE  = 'IL';
    public const IMPRESSION  = 'IM';
    public const INCH  = 'INH';
    public const SQUARE_INCH  = 'INK';
    public const INCH_CUBED  = 'INQ';
    public const INSURANCE_POLICY  = 'IP';
    public const COUNT_PER_CENTIMETRE  = 'IT';
    public const INCH_PER_SECOND_LINEAR_SPEED  = 'IU';
    public const INCH_PER_SECOND_SQUARED_ACCELERATION  = 'IV';
    public const JOULE_PER_KILOGRAM  = 'J2';
    public const JUMBO  = 'JB';
    public const JOULE_PER_KELVIN  = 'JE';
    public const JUG  = 'JG';
    public const MEGAJOULE_PER_KILOGRAM  = 'JK';
    public const MEGAJOULE_PER_CUBIC_METRE  = 'JM';
    public const JOINT  = 'JO';
    public const JOULE  = 'JOU';
    public const JAR  = 'JR';
    public const KILOWATT_DEMAND  = 'K1';
    public const KILOVOLT_AMPERE_REACTIVE_DEMAND  = 'K2';
    public const KILOVOLT_AMPERE_REACTIVE_HOUR  = 'K3';
    public const KILOVOLT_AMPERE_REACTIVE  = 'K5';
    public const KILOLITRE  = 'K6';
    public const CAKE  = 'KA';
    public const KILOCHARACTER  = 'KB';
    public const KILOBAR  = 'KBA';
    public const KILOGRAM_DECIMAL  = 'KD';
    public const KELVIN  = 'KEL';
    public const KILOPACKET  = 'KF';
    public const KEG  = 'KG';
    public const KILOGRAM  = 'KGM';
    public const KILOGRAM_PER_SECOND  = 'KGS';
    public const KILOHERTZ  = 'KHZ';
    public const KILOGRAM_PER_MILLIMETRE_WIDTH  = 'KI';
    public const KILOSEGMENT  = 'KJ';
    public const KILOJOULE  = 'KJO';
    public const KILOGRAM_PER_METRE  = 'KL';
    public const KILOMETRE_PER_HOUR  = 'KMH';
    public const SQUARE_KILOMETRE  = 'KMK';
    public const KILOGRAM_PER_CUBIC_METRE  = 'KMQ';
    public const KILOGRAM_OF_NITROGEN  = 'KNI';
    public const KILOGRAM_NAMED_SUBSTANCE  = 'KNS';
    public const KNOT  = 'KNT';
    public const MILLIEQUIVALENCE_CAUSTIC_POTASH_PER_GRAM_OF_PRODUCT  = 'KO';
    public const KILOPASCAL  = 'KPA';
    public const KILOGRAM_OF_POTASSIUM_HYDROXIDE_CAUSTIC_POTASH  = 'KPH';
    public const KILOGRAM_OF_POTASSIUM_OXIDE  = 'KPO';
    public const KILOGRAM_OF_PHOSPHORUS_PENTOXIDE_PHOSPHORIC_ANHYDRIDE  = 'KPP';
    public const KILORÃ¶NTGEN  = 'KR';
    public const THOUSAND_POUND_PER_SQUARE_INCH  = 'KS';
    public const KILOGRAM_OF_SUBSTANCE_90__DRY  = 'KSD';
    public const KILOGRAM_OF_SODIUM_HYDROXIDE_CAUSTIC_SODA  = 'KSH';
    public const KIT  = 'KT';
    public const KILOMETRE  = 'KTM';
    public const KILOTONNE  = 'KTN';
    public const KILOGRAM_OF_URANIUM  = 'KUR';
    public const KILOVOLT___AMPERE  = 'KVA';
    public const KILOVAR  = 'KVR';
    public const KILOVOLT  = 'KVT';
    public const KILOGRAMS_PER_MILLIMETER  = 'KW';
    public const KILOWATT_HOUR  = 'KWH';
    public const KILOWATT  = 'KWT';
    public const MILLILITRE_PER_KILOGRAM  = 'KX';
    public const LITRE_PER_MINUTE  = 'L2';
    public const POUND_PER_CUBIC_INCH  = 'LA';
    public const POUND  = 'LBR';
    public const TROY_POUND_US  = 'LBT';
    public const LINEAR_CENTIMETRE  = 'LC';
    public const LITRE_PER_DAY  = 'LD';
    public const LITE  = 'LE';
    public const LEAF  = 'LEF';
    public const LINEAR_FOOT  = 'LF';
    public const LABOUR_HOUR  = 'LH';
    public const LINEAR_INCH  = 'LI';
    public const LARGE_SPRAY  = 'LJ';
    public const LINK  = 'LK';
    public const LINEAR_METRE  = 'LM';
    public const LENGTH  = 'LN';
    public const LOT  = 'LO';
    public const LIQUID_POUND  = 'LP';
    public const LITRE_OF_PURE_ALCOHOL  = 'LPA';
    public const LAYER  = 'LR';
    public const LUMP_SUM  = 'LS';
    public const TON_UK_OR_LONGTON_US  = 'LTN';
    public const LITRE  = 'LTR';
    public const LUMEN  = 'LUM';
    public const LUX  = 'LUX';
    public const LINEAR_YARD_PER_POUND  = 'LX';
    public const LINEAR_YARD  = 'LY';
    public const MAGNETIC_TAPE  = 'M0';
    public const MILLIGRAMS_PER_LITRE  = 'M1';
    public const MONETARY_VALUE  = 'M4';
    public const MICROCURIE  = 'M5';
    public const MICRO_INCH  = 'M7';
    public const MILLION_BTU_PER_1000_CUBIC_FEET  = 'M9';
    public const MACHINE_PER_UNIT  = 'MA';
    public const MEGA_LITRE  = 'MAL';
    public const MEGAMETRE  = 'MAM';
    public const MEGAWATT  = 'MAW';
    public const THOUSAND_STANDARD_BRICK_EQUIVALENT  = 'MBE';
    public const THOUSAND_BOARD_FEET  = 'MBF';
    public const MILLIBAR  = 'MBR';
    public const MICROGRAM  = 'MC';
    public const MILLICURIE  = 'MCU';
    public const AIR_DRY_METRIC_TON  = 'MD';
    public const MILLIGRAM_PER_SQUARE_FOOT_PER_SIDE  = 'MF';
    public const MILLIGRAM  = 'MGM';
    public const MEGAHERTZ  = 'MHZ';
    public const SQUARE_MILE  = 'MIK';
    public const THOUSAND  = 'MIL';
    public const MILLION  = 'MIO';
    public const MILLION_INTERNATIONAL_UNIT  = 'MIU';
    public const MILLIGRAM_PER_SQUARE_INCH  = 'MK';
    public const MILLIARD  = 'MLD';
    public const MILLILITRE  = 'MLT';
    public const SQUARE_MILLIMETRE  = 'MMK';
    public const CUBIC_MILLIMETRE  = 'MMQ';
    public const MILLIMETRE  = 'MMT';
    public const MONTH  = 'MON';
    public const MEGAPASCAL  = 'MPA';
    public const THOUSAND_METRE  = 'MQ';
    public const CUBIC_METRE_PER_HOUR  = 'MQH';
    public const CUBIC_METRE_PER_SECOND  = 'MQS';
    public const METRE_PER_SECOND_SQUARED  = 'MSK';
    public const MAT  = 'MT';
    public const SQUARE_METRE  = 'MTK';
    public const CUBIC_METRE  = 'MTQ';
    public const METRE  = 'MTR';
    public const METRE_PER_SECOND  = 'MTS';
    public const NUMBER_OF_MULTS  = 'MV';
    public const MEGAVOLT___AMPERE  = 'MVA';
    public const MEGAWATT_HOUR_1000_KWH  = 'MWH';
    public const PEN_CALORIE  = 'N1';
    public const NUMBER_OF_LINES  = 'N2';
    public const PRINT_POINT  = 'N3';
    public const MILLIGRAM_PER_KILOGRAM  = 'NA';
    public const NUMBER_OF__ARTICLES  = 'NAR';
    public const BARGE  = 'NB';
    public const NUMBER_OF_BOBBINS  = 'NBB';
    public const CAR  = 'NC';
    public const NUMBER_OF_CELLS  = 'NCL';
    public const NET_BARREL  = 'ND';
    public const NET_LITRE  = 'NE';
    public const NEWTON  = 'NEW';
    public const MESSAGE  = 'NF';
    public const NET_GALLON_US  = 'NG';
    public const MESSAGE_HOUR  = 'NH';
    public const NET_IMPERIAL_GALLON  = 'NI';
    public const NUMBER_OF_INTERNATIONAL_UNITS  = 'NIU';
    public const NUMBER_OF_SCREENS  = 'NJ';
    public const LOAD  = 'NL';
    public const NAUTICAL_MILE  = 'NMI';
    public const NUMBER_OF_PACKS  = 'NMP';
    public const TRAIN  = 'NN';
    public const NUMBER_OF_PARCELS  = 'NPL';
    public const NUMBER_OF_PAIRS  = 'NPR';
    public const NUMBER_OF_PARTS  = 'NPT';
    public const MHO  = 'NQ';
    public const MICROMHO  = 'NR';
    public const NUMBER_OF_ROLLS  = 'NRL';
    public const NET_TON  = 'NT';
    public const NET_REGISTER_TON  = 'NTT';
    public const NEWTON_METRE  = 'NU';
    public const VEHICLE  = 'NV';
    public const PART_PER_THOUSAND  = 'NX';
    public const POUND_PER_AIR_DRY_METRIC_TON  = 'NY';
    public const PANEL  = 'OA';
    public const OHM  = 'OHM';
    public const OUNCE_PER_SQUARE_YARD  = 'ON';
    public const OUNCE  = 'ONZ';
    public const TWO_PACK  = 'OP';
    public const OVERTIME_HOUR  = 'OT';
    public const OUNCE_AV  = 'OZ';
    public const FLUID_OUNCE_US  = 'OZA';
    public const FLUID_OUNCE_UK  = 'OZI';
    public const PAGE___ELECTRONIC  = 'P0';
    public const PERCENT  = 'P1';
    public const POUND_PER_FOOT  = 'P2';
    public const THREE_PACK  = 'P3';
    public const FOUR_PACK  = 'P4';
    public const FIVE_PACK  = 'P5';
    public const SIX_PACK  = 'P6';
    public const SEVEN_PACK  = 'P7';
    public const EIGHT_PACK  = 'P8';
    public const NINE_PACK  = 'P9';
    public const PACKET  = 'PA';
    public const PASCAL  = 'PAL';
    public const PAIR_INCH  = 'PB';
    public const PAD  = 'PD';
    public const POUND_EQUIVALENT  = 'PE';
    public const PALLET_LIFT  = 'PF';
    public const PLATE  = 'PG';
    public const PROOF_GALLON  = 'PGL';
    public const PITCH  = 'PI';
    public const PACKAGE  = 'PK';
    public const PAIL  = 'PL';
    public const POUND_PERCENTAGE  = 'PM';
    public const POUND_NET  = 'PN';
    public const POUND_PER_INCH_OF_LENGTH  = 'PO';
    public const PAGE_PER_INCH  = 'PQ';
    public const PAIR  = 'PR';
    public const POUND_FORCE_PER_SQUARE_INCH  = 'PS';
    public const PINT_US  = 'PT';
    public const DRY_PINT_US  = 'PTD';
    public const PINT__UK  = 'PTI';
    public const LIQUID_PINT_US  = 'PTL';
    public const TRAY___TRAY_PACK  = 'PU';
    public const HALF_PINT_US  = 'PV';
    public const POUND_PER_INCH_OF_WIDTH  = 'PW';
    public const PECK_DRY_US  = 'PY';
    public const PECK_DRY_UK  = 'PZ';
    public const MEAL  = 'Q3';
    public const PAGE___FACSIMILE  = 'QA';
    public const QUARTER_OF_A_YEAR  = 'QAN';
    public const PAGE___HARDCOPY  = 'QB';
    public const QUARTER_DOZEN  = 'QD';
    public const QUARTER_HOUR  = 'QH';
    public const QUARTER_KILOGRAM  = 'QK';
    public const QUIRE  = 'QR';
    public const QUART_US  = 'QT';
    public const DRY_QUART_US  = 'QTD';
    public const QUART_UK  = 'QTI';
    public const LIQUID_QUART_US  = 'QTL';
    public const QUARTER_UK  = 'QTR';
    public const PICA  = 'R1';
    public const CALORIE  = 'R4';
    public const THOUSAND_CUBIC_METRE  = 'R9';
    public const RACK  = 'RA';
    public const ROD  = 'RD';
    public const RING  = 'RG';
    public const RUNNING_OR_OPERATING_HOUR  = 'RH';
    public const ROLL_METRIC_MEASURE  = 'RK';
    public const REEL  = 'RL';
    public const REAM  = 'RM';
    public const REAM_METRIC_MEASURE  = 'RN';
    public const ROLL  = 'RO';
    public const POUND_PER_REAM  = 'RP';
    public const REVOLUTIONS_PER_MINUTE  = 'RPM';
    public const REVOLUTIONS_PER_SECOND  = 'RPS';
    public const RESET  = 'RS';
    public const REVENUE_TON_MILE  = 'RT';
    public const RUN  = 'RU';
    public const SQUARE_FOOT_PER_SECOND  = 'S3';
    public const SQUARE_METRE_PER_SECOND  = 'S4';
    public const SIXTY_FOURTHS_OF_AN_INCH  = 'S5';
    public const SESSION  = 'S6';
    public const STORAGE_UNIT  = 'S7';
    public const STANDARD_ADVERTISING_UNIT  = 'S8';
    public const SACK  = 'SA';
    public const HALF_YEAR_6_MONTHS  = 'SAN';
    public const SCORE  = 'SCO';
    public const SCRUPLE  = 'SCR';
    public const SOLID_POUND  = 'SD';
    public const SECTION  = 'SE';
    public const SECOND  = 'SEC';
    public const SET  = 'SET';
    public const SEGMENT  = 'SG';
    public const SHIPPING_TON  = 'SHT';
    public const SIEMENS  = 'SIE';
    public const SPLIT_TANKTRUCK  = 'SK';
    public const SLIPSHEET  = 'SL';
    public const MILE_STATUTE_MILE  = 'SMI';
    public const SQUARE_ROD  = 'SN';
    public const SPOOL  = 'SO';
    public const SHELF_PACKAGE  = 'SP';
    public const SQUARE  = 'SQ';
    public const STRIP  = 'SR';
    public const SHEET__METRIC_MEASURE  = 'SS';
    public const SHORT_STANDARD_7200_MATCHES  = 'SST';
    public const SHEET  = 'ST';
    public const STONE_UK  = 'STI';
    public const TON_US_OR_SHORT_TON_UK_US  = 'STN';
    public const SKID  = 'SV';
    public const SKEIN  = 'SW';
    public const SHIPMENT  = 'SX';
    public const TELECOMMUNICATION_LINE_IN_SERVICE  = 'T0';
    public const THOUSAND_POUND_GROSS  = 'T1';
    public const THOUSAND_PIECE  = 'T3';
    public const THOUSAND_BAG  = 'T4';
    public const THOUSAND_CASING  = 'T5';
    public const THOUSAND_GALLON_US  = 'T6';
    public const THOUSAND_IMPRESSION  = 'T7';
    public const THOUSAND_LINEAR_INCH  = 'T8';
    public const TENTH_CUBIC_FOOT  = 'TA';
    public const KILOAMPERE_HOUR_THOUSAND_AMPERE_HOUR  = 'TAH';
    public const TRUCKLOAD  = 'TC';
    public const THERM  = 'TD';
    public const TOTE  = 'TE';
    public const TEN_SQUARE_YARD  = 'TF';
    public const THOUSAND_SQUARE_INCH  = 'TI';
    public const THOUSAND_SQUARE_CENTIMETRE  = 'TJ';
    public const TANK_RECTANGULAR  = 'TK';
    public const THOUSAND_FEET_LINEAR  = 'TL';
    public const TIN  = 'TN';
    public const TONNE_METRIC_TON  = 'TNE';
    public const TEN_PACK  = 'TP';
    public const TEN_PAIR  = 'TPR';
    public const THOUSAND_FEET  = 'TQ';
    public const THOUSAND_CUBIC_METRE_PER_DAY  = 'TQD';
    public const TEN_SQUARE_FEET  = 'TR';
    public const TRILLION_EUR  = 'TRL';
    public const THOUSAND_SQUARE_FEET  = 'TS';
    public const TONNE_OF_SUBSTANCE_90__DRY  = 'TSD';
    public const TON_OF_STEAM_PER_HOUR  = 'TSH';
    public const THOUSAND_LINEAR_METRE  = 'TT';
    public const TUBE  = 'TU';
    public const THOUSAND_KILOGRAM  = 'TV';
    public const THOUSAND_SHEET  = 'TW';
    public const TANK_CYLINDRICAL  = 'TY';
    public const TREATMENT  = 'U1';
    public const TABLET  = 'U2';
    public const TORR  = 'UA';
    public const TELECOMMUNICATION__LINE_IN_SERVICE_AVERAGE  = 'UB';
    public const TELECOMMUNICATION_PORT  = 'UC';
    public const TENTH_MINUTE  = 'UD';
    public const TENTH_HOUR  = 'UE';
    public const USAGE_PER_TELECOMMUNICATION_LINE_AVERAGE  = 'UF';
    public const TEN_THOUSAND_YARD  = 'UH';
    public const MILLION_UNIT  = 'UM';
    public const VOLT_AMPERE_PER_KILOGRAM  = 'VA';
    public const VIAL  = 'VI';
    public const VOLT  = 'VLT';
    public const BULK  = 'VQ';
    public const VISIT  = 'VS';
    public const WET_KILO  = 'W2';
    public const TWO_WEEK  = 'W4';
    public const WATT_PER_KILOGRAM  = 'WA';
    public const WET_POUND  = 'WB';
    public const CORD  = 'WCD';
    public const WET_TON  = 'WE';
    public const WEBER  = 'WEB';
    public const WEEK  = 'WEE';
    public const WINE_GALLON  = 'WG';
    public const WHEEL  = 'WH';
    public const WATT_HOUR  = 'WHR';
    public const WEIGHT_PER_SQUARE_INCH  = 'WI';
    public const WORKING_MONTH  = 'WM';
    public const WRAP  = 'WR';
    public const STANDARD  = 'WSD';
    public const WATT  = 'WTT';
    public const MILLILITRE_OF_WATER  = 'WW';
    public const CHAIN  = 'X1';
    public const SQUARE_YARD  = 'YDK';
    public const CUBIC_YARD  = 'YDQ';
    public const HUNDRED_LINEAR_YARD  = 'YL';
    public const YARD  = 'YRD';
    public const TEN_YARD  = 'YT';
    public const LIFT_VAN  = 'Z1';
    public const CHEST  = 'Z2';
    public const CASK  = 'Z3';
    public const HOGSHEAD  = 'Z4';
    public const LUG  = 'Z5';
    public const CONFERENCE_POINT  = 'Z6';
    public const NEWSPAGE_AGATE_LINE  = 'Z8';
    public const PAGE  = 'ZP';
    public const MUTUALLY_DEFINED  = 'ZZ';
    
}
